class Switch
{
  private int x, y, largeur, hauteur;
  private PImage imgOn, imgOff;
  private Boolean etatMouse, etatSwitch;
  private Boolean impulse;
  private char cmdeOn, cmdeOff;
  
  public Switch(int x, int y, int largeur, int hauteur, PImage imgOn, PImage imgOff, char cmdeOn, char cmdeOff, Boolean impulse)
  {
    this.x = x;
    this.y = y;
    this.largeur=largeur;
    this.hauteur = hauteur;
    this.imgOn = imgOn;
    this.imgOff = imgOff;
    this.cmdeOn = cmdeOn;
    this.cmdeOff = cmdeOff;
    this.impulse = impulse;
    this.etatMouse = false;
    this.etatSwitch = false;
  }
  
  public void Draw()
  {
    if(!mousePressed) {
      if (impulse) etatSwitch = false;
      etatMouse = false;
    }
    else {
      if ((mouseX >= x-largeur/2 && mouseX <= x + largeur/2) && (mouseY >= y - hauteur/2 && mouseY <= y + hauteur/2)) {
         if (impulse) {
           if (!etatMouse) {
             etatMouse = true;
             etatSwitch = true;
             envoi_octet((byte)cmdeOn);
           }
         }
         else {
           if (!etatMouse) {
             etatMouse = true;
             if (etatSwitch) envoi_octet((byte)cmdeOff);
             else envoi_octet((byte)cmdeOn);
             etatSwitch = !etatSwitch;  
           }
         }
      }
    }
    pushMatrix();
    imageMode(CENTER);
    translate(x, y);       // place la reference pour le tachy au centre horizontal de la fenetre
    if (etatSwitch) image(imgOn, 0, 0, largeur, hauteur);
      else image(imgOff, 0, 0, largeur, hauteur);
    popMatrix();
  }
}
